USE [msdb]
GO

/****** Object:  Job [Active_Session_History]    Script Date: 11/10/2015 6:35:02 PM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 11/10/2015 6:35:02 PM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'Active_Session_History', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'sa', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Active_session_History]    Script Date: 11/10/2015 6:35:02 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Active_session_History', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'USE [ADMINDB]
GO

INSERT INTO [dbo].[ActiveSessionHistory]
           ([Record_Time]
           ,[request_id]
           ,[ReqStatus]
           ,[SessStatus]
           ,[Sess_Session_Id]
           ,[wait_type]
           ,[wait_time]
           ,[wait_resource]
           ,[command]
           ,[cpu_time]
           ,[total_elapsed_time]
           ,[reads]
           ,[writes]
           ,[logical_reads]
           ,[granted_query_memory]
           ,[memory_usage]
           ,[last_read]
           ,[last_write]
           ,[connect_time]
           ,[Login_Name]
           --,[query_plan]
           ,[Req_Session_Id]
           ,[blocking_session_id]
           ,[percent_complete]
           ,[estimated_finish_time]
           ,[DatabaseName]
           ,[ProgramName]
           ,[SQLText]
           ,[SQLStatement]
           ,[host_name]
           --,[size_in_bytes]
           ,[nt_user_name]
           ,[nt_domain])
select getdate(), br.request_id, br.status AS ReqStatus, bs.status AS SessStatus, bs.session_id AS Sess_Session_Id, br.wait_type,  br.wait_time, br.wait_resource, br.command,
br.cpu_time, br.total_elapsed_time, br.reads, br.writes, br.logical_reads, br.granted_query_memory, bs.memory_usage, bc.last_read, bc.last_write,
bc.connect_time, bs.Login_Name, --bqp.query_plan, 
  br.session_id AS Req_Session_Id, br.blocking_session_id, br.percent_complete, estimated_finish_time = DATEADD(MILLISECOND, br.estimated_completion_time, CURRENT_TIMESTAMP),
db_name(br.database_id) as DatabaseName,  bs.program_name AS ProgramName, 
  btx.[text] AS SQLText, 
      (SELECT TOP 1 SUBSTRING(btx.text,statement_start_offset / 2+1 , 
      ( (CASE WHEN statement_end_offset = -1 
         THEN (LEN(CONVERT(nvarchar(max),btx.text)) * 2) 
         ELSE statement_end_offset END)  - statement_start_offset) / 2+1))  AS SQLStatement, bs.[host_name]
  --, cp.size_in_bytes
  , bs.nt_user_name, bs.nt_domain
 FROM sys.dm_exec_sessions AS bs 
      INNER JOIN [master].[sys].[dm_exec_requests] br on bs.session_id = br.session_id
	  INNER JOIN [master].[sys].[dm_exec_connections] bc on bc.connection_id = br.connection_id 
 CROSS APPLY sys.dm_exec_sql_text(br.[sql_handle]) AS btx
--CROSS APPLY master.sys.dm_exec_query_plan(br.plan_handle) AS bqp
--inner join master.sys.dm_exec_cached_plans cp on cp.plan_handle = br.plan_handle
 WHERE bs.session_id <>  @@spid;
 GO', 
		@database_name=N'ADMINDB', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Active_Session_History_Schedule', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=2, 
		@freq_subday_interval=15, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20150423, 
		@active_end_date=99991231, 
		@active_start_time=0, 
		@active_end_time=235959, 
		@schedule_uid=N'2c63bb5e-5801-407b-866a-43cb4a122ea1'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:

GO

